Index: branches/HTM-3.1-LG/source/Lib/TLibCommon/TComDataCU.cpp
===================================================================
--- branches/HTM-3.1-LG/source/Lib/TLibCommon/TComDataCU.cpp	(revision 96)
+++ branches/HTM-3.1-LG/source/Lib/TLibCommon/TComDataCU.cpp	(revision 97)
@@ -6472,3 +7108,626 @@
 #endif
 
+#if LGE_EDGE_INTRA
+Void TComDataCU::reconPartition( UInt uiAbsPartIdx, UInt uiDepth, Bool bLeft, UChar ucStartPos, UChar ucNumEdge, UChar* pucEdgeCode, Bool* pbRegion )
+{
+	Int iWidth;
+	Int iHeight;
+	if( uiDepth == 0 )
+	{
+		iWidth = 64;
+		iHeight = 64;
+	}
+	else if( uiDepth == 1 )
+	{
+		iWidth = 32;
+		iHeight = 32;
+	}
+	else if( uiDepth == 2 )
+	{
+		iWidth = 16;
+		iHeight = 16;
+	}
+	else if( uiDepth == 3 )
+	{
+		iWidth = 8;
+		iHeight = 8;
+	}
+	else // uiDepth == 4
+	{
+		iWidth = 4;
+		iHeight = 4;
+	}
+
+	Int iPtr = 0;
+	Int iX, iY;
+	Int iDir = -1;
+	Int iDiffX = 0, iDiffY = 0;
+
+	// 1. Edge Code -> Vert & Horz Edges
+	Bool*  pbEdge = (Bool*) xMalloc( Bool, 4 * iWidth * iHeight );
+
+	for( UInt ui = 0; ui < 4 * iWidth * iHeight; ui++ )
+		pbEdge  [ ui ] = false;
+
+	// Direction : left(0), right(1), top(2), bottom(3), left-top(4), right-top(5), left-bottom(6), right-bottom(7)
+	// Code      : 0deg(0), 45deg(1), -45deg(2), 90deg(3), -90deg(4), 135deg(5), -135deg(6)
+	const UChar tableDir[8][7] = { { 0, 6, 4, 3, 2, 7, 5 },
+	{ 1, 5, 7, 2, 3, 4, 6 },
+	{ 2, 4, 5, 0, 1, 6, 7 },
+	{ 3, 7, 6, 1, 0, 5, 4 },
+	{ 4, 0, 2, 6, 5, 3, 1 },
+	{ 5, 2, 1, 4, 7, 0, 3 },
+	{ 6, 3, 0, 7, 4, 1, 2 },
+	{ 7, 1, 3, 5, 6, 2, 0 }};
+
+	UChar ucCode = pucEdgeCode[iPtr++];
+
+	if( !bLeft )
+	{
+		iX = ucStartPos;
+		iY = 0;
+
+		switch(ucCode)
+		{
+		case 0: // bottom
+			iDir = 3;
+			if(iX > 0) pbEdge[ 2 * (iX - 1) + 1 + iY * 4 * iWidth ] = true;
+			break;
+		case 2: // left-bottom
+			iDir = 6;
+			if(iX > 0) pbEdge[ 2 * (iX - 1) + 1 + iY * 4 * iWidth ] = true;
+			break;
+		case 1: // right-bottom
+			iDir = 7;
+			if(iX > 0) pbEdge[ 2 * (iX - 1) + 1 + iY * 4 * iWidth ] = true;
+			if(iY < iHeight - 1) pbEdge[ 2 * iX + (2 * (iY + 0) + 1) * 2 * iWidth ] = true;
+			break;
+		case 4: // left
+			iDir = 0;
+			assert(false);
+			break;
+		case 3: // right
+			iDir = 1;
+			if(iX > 0) pbEdge[ 2 * (iX - 1) + 1 + iY * 4 * iWidth ] = true;
+			if(iY < iHeight - 1) pbEdge[ 2 * iX + (2 * (iY + 0) + 1) * 2 * iWidth ] = true;
+			break;
+		}
+	}
+	else
+	{
+		iX = 0;
+		iY = ucStartPos;
+
+		switch(ucCode)
+		{
+		case 0: // right
+			iDir = 1;
+			if(iY < iHeight - 1) pbEdge[ 2 * iX + (2 * (iY + 0) + 1) * 2 * iWidth ] = true;
+			break;
+		case 1: // right-top
+			iDir = 5;
+			if(iY < iHeight - 1) pbEdge[ 2 * iX + (2 * (iY + 0) + 1) * 2 * iWidth ] = true;
+			if(iX < iWidth - 1) pbEdge[ 2 * (iX + 0) + 1 + iY * 4 * iWidth ] = true;
+			break;
+		case 2: // right-bottom
+			iDir = 7;
+			if(iY < iHeight - 1) pbEdge[ 2 * iX + (2 * (iY + 0) + 1) * 2 * iWidth ] = true;
+			break;
+		case 3: // top
+			iDir = 2;
+			if(iY < iHeight - 1) pbEdge[ 2 * iX + (2 * (iY + 0) + 1) * 2 * iWidth ] = true;
+			if(iX < iWidth - 1) pbEdge[ 2 * (iX + 0) + 1 + iY * 4 * iWidth ] = true;
+			break;
+		case 4: // bottom
+			iDir = 3;
+			assert(false);
+			break;
+		}
+	}
+
+	switch( iDir )
+	{
+	case 0: // left
+		iDiffX = -1;
+		iDiffY = 0;
+		break;
+	case 1: // right
+		iDiffX = +1;
+		iDiffY = 0;
+		break;
+	case 2: // top
+		iDiffX = 0;
+		iDiffY = -1;
+		break;
+	case 3: // bottom
+		iDiffX = 0;
+		iDiffY = +1;
+		break;
+	case 4: // left-top
+		iDiffX = -1;
+		iDiffY = -1;
+		break;
+	case 5: // right-top
+		iDiffX = +1;
+		iDiffY = -1;
+		break;
+	case 6: // left-bottom
+		iDiffX = -1;
+		iDiffY = +1;
+		break;
+	case 7: // right-bottom
+		iDiffX = +1;
+		iDiffY = +1;
+		break;
+	}
+
+	iX += iDiffX;
+	iY += iDiffY;
+
+	while( iPtr < ucNumEdge )
+	{
+		ucCode = pucEdgeCode[iPtr++];
+
+		Int iNewDir = tableDir[iDir][ucCode];
+
+		switch( iNewDir )
+		{
+		case 0: // left
+			iDiffX = -1;
+			iDiffY = 0;
+			break;
+		case 1: // right
+			iDiffX = +1;
+			iDiffY = 0;
+			break;
+		case 2: // top
+			iDiffX = 0;
+			iDiffY = -1;
+			break;
+		case 3: // bottom
+			iDiffX = 0;
+			iDiffY = +1;
+			break;
+		case 4: // left-top
+			iDiffX = -1;
+			iDiffY = -1;
+			break;
+		case 5: // right-top
+			iDiffX = +1;
+			iDiffY = -1;
+			break;
+		case 6: // left-bottom
+			iDiffX = -1;
+			iDiffY = +1;
+			break;
+		case 7: // right-bottom
+			iDiffX = +1;
+			iDiffY = +1;
+			break;
+		}
+
+		switch( iDir )
+		{
+		case 0: // left
+			switch( ucCode )
+			{
+			case 0:
+			case 2:
+				if(iY > 0) pbEdge[ 2 * iX + (2 * (iY - 1) + 1) * 2 * iWidth ] = true;
+				break;
+			case 1:
+			case 3:
+				if(iY > 0) pbEdge[ 2 * iX + (2 * (iY - 1) + 1) * 2 * iWidth ] = true;
+				if(iX > 0) pbEdge[ 2 * (iX - 1) + 1 + iY * 4 * iWidth ] = true;
+				break;
+			case 4:
+			case 6:
+				// no
+				break;
+			case 5:
+				if(iY > 0) pbEdge[ 2 * iX + (2 * (iY - 1) + 1) * 2 * iWidth ] = true;
+				if(iY < iHeight - 1) pbEdge[ 2 * iX + (2 * (iY + 0) + 1) * 2 * iWidth ] = true;
+				if(iX > 0) pbEdge[ 2 * (iX - 1) + 1 + iY * 4 * iWidth ] = true;
+				break;
+			}
+			break;
+		case 1: // right
+			switch( ucCode )
+			{
+			case 0:
+			case 2:
+				if(iY < iHeight - 1) pbEdge[ 2 * iX + (2 * (iY + 0) + 1) * 2 * iWidth ] = true;
+				break;
+			case 1:
+			case 3:
+				if(iY < iHeight - 1) pbEdge[ 2 * iX + (2 * (iY + 0) + 1) * 2 * iWidth ] = true;
+				if(iX < iWidth - 1) pbEdge[ 2 * (iX + 0) + 1 + iY * 4 * iWidth ] = true;
+				break;
+			case 4:
+			case 6:
+				// no
+				break;
+			case 5:
+				if(iY > 0) pbEdge[ 2 * iX + (2 * (iY - 1) + 1) * 2 * iWidth ] = true;
+				if(iY < iHeight - 1) pbEdge[ 2 * iX + (2 * (iY + 0) + 1) * 2 * iWidth ] = true;
+				if(iX < iWidth - 1) pbEdge[ 2 * (iX + 0) + 1 + iY * 4 * iWidth ] = true;
+				break;
+			}
+			break;
+		case 2: // top
+			switch( ucCode )
+			{
+			case 0:
+			case 2:
+				if(iX < iWidth - 1) pbEdge[ 2 * (iX + 0) + 1 + iY * 4 * iWidth ] = true;
+				break;
+			case 1:
+			case 3:
+				if(iY > 0) pbEdge[ 2 * iX + (2 * (iY - 1) + 1) * 2 * iWidth ] = true;
+				if(iX < iWidth - 1) pbEdge[ 2 * (iX + 0) + 1 + iY * 4 * iWidth ] = true;
+				break;
+			case 4:
+			case 6:
+				// no
+				break;
+			case 5:
+				if(iY > 0) pbEdge[ 2 * iX + (2 * (iY - 1) + 1) * 2 * iWidth ] = true;
+				if(iX > 0) pbEdge[ 2 * (iX - 1) + 1 + iY * 4 * iWidth ] = true;
+				if(iX < iWidth - 1) pbEdge[ 2 * (iX + 0) + 1 + iY * 4 * iWidth ] = true;
+				break;
+			}
+			break;
+		case 3: // bottom
+			switch( ucCode )
+			{
+			case 0:
+			case 2:
+				if(iX > 0) pbEdge[ 2 * (iX - 1) + 1 + iY * 4 * iWidth ] = true;
+				break;
+			case 1:
+			case 3:
+				if(iX > 0) pbEdge[ 2 * (iX - 1) + 1 + iY * 4 * iWidth ] = true;
+				if(iY < iHeight - 1) pbEdge[ 2 * iX + (2 * (iY + 0) + 1) * 2 * iWidth ] = true;
+				break;
+			case 4:
+			case 6:
+				// no
+				break;
+			case 5:
+				if(iX > 0) pbEdge[ 2 * (iX - 1) + 1 + iY * 4 * iWidth ] = true;
+				if(iX < iWidth - 1) pbEdge[ 2 * (iX + 0) + 1 + iY * 4 * iWidth ] = true;
+				if(iY < iHeight - 1) pbEdge[ 2 * iX + (2 * (iY + 0) + 1) * 2 * iWidth ] = true;
+				break;
+			}
+			break;
+		case 4: // left-top
+			switch( ucCode )
+			{
+			case 0:
+			case 1:
+				if(iY > 0) pbEdge[ 2 * iX + (2 * (iY - 1) + 1) * 2 * iWidth ] = true;
+				if(iX < iWidth - 1) pbEdge[ 2 * (iX + 0) + 1 + iY * 4 * iWidth ] = true;
+				break;
+			case 2:
+			case 4:
+				if(iX < iWidth - 1) pbEdge[ 2 * (iX + 0) + 1 + iY * 4 * iWidth ] = true;
+				break;
+			case 3:
+			case 5:
+				if(iY > 0) pbEdge[ 2 * iX + (2 * (iY - 1) + 1) * 2 * iWidth ] = true;
+				if(iX > 0) pbEdge[ 2 * (iX - 1) + 1 + iY * 4 * iWidth ] = true;
+				if(iX < iWidth - 1) pbEdge[ 2 * (iX + 0) + 1 + iY * 4 * iWidth ] = true;
+				break;
+			case 6:
+				// no
+				break;
+			}
+			break;
+		case 5: // right-top
+			switch( ucCode )
+			{
+			case 0:
+			case 1:
+				if(iY < iHeight - 1) pbEdge[ 2 * iX + (2 * (iY + 0) + 1) * 2 * iWidth ] = true;
+				if(iX < iWidth - 1) pbEdge[ 2 * (iX + 0) + 1 + iY * 4 * iWidth ] = true;
+				break;
+			case 2:
+			case 4:
+				if(iY < iHeight - 1) pbEdge[ 2 * iX + (2 * (iY + 0) + 1) * 2 * iWidth ] = true;
+				break;
+			case 3:
+			case 5:
+				if(iY > 0) pbEdge[ 2 * iX + (2 * (iY - 1) + 1) * 2 * iWidth ] = true;
+				if(iY < iHeight - 1) pbEdge[ 2 * iX + (2 * (iY + 0) + 1) * 2 * iWidth ] = true;
+				if(iX < iWidth - 1) pbEdge[ 2 * (iX + 0) + 1 + iY * 4 * iWidth ] = true;
+				break;
+			case 6:
+				// no
+				break;
+			}
+			break;
+		case 6: // left-bottom
+			switch( ucCode )
+			{
+			case 0:
+			case 1:
+				if(iY > 0) pbEdge[ 2 * iX + (2 * (iY - 1) + 1) * 2 * iWidth ] = true;
+				if(iX > 0) pbEdge[ 2 * (iX - 1) + 1 + iY * 4 * iWidth ] = true;
+				break;
+			case 2:
+			case 4:
+				if(iY > 0) pbEdge[ 2 * iX + (2 * (iY - 1) + 1) * 2 * iWidth ] = true;
+				break;
+			case 3:
+			case 5:
+				if(iY > 0) pbEdge[ 2 * iX + (2 * (iY - 1) + 1) * 2 * iWidth ] = true;
+				if(iX > 0) pbEdge[ 2 * (iX - 1) + 1 + iY * 4 * iWidth ] = true;
+				if(iY < iHeight - 1) pbEdge[ 2 * iX + (2 * (iY + 0) + 1) * 2 * iWidth ] = true;
+				break;
+			case 6:
+				// no
+				break;
+			}
+			break;
+		case 7: // right-bottom
+			switch( ucCode )
+			{
+			case 0:
+			case 1:
+				if(iY < iHeight - 1) pbEdge[ 2 * iX + (2 * (iY + 0) + 1) * 2 * iWidth ] = true;
+				if(iX > 0) pbEdge[ 2 * (iX - 1) + 1 + iY * 4 * iWidth ] = true;
+				break;
+			case 2:
+			case 4:
+				if(iX > 0) pbEdge[ 2 * (iX - 1) + 1 + iY * 4 * iWidth ] = true;
+				break;
+			case 3:
+			case 5:
+				if(iX > 0) pbEdge[ 2 * (iX - 1) + 1 + iY * 4 * iWidth ] = true;
+				if(iX < iWidth - 1) pbEdge[ 2 * (iX + 0) + 1 + iY * 4 * iWidth ] = true;
+				if(iY < iHeight - 1) pbEdge[ 2 * iX + (2 * (iY + 0) + 1) * 2 * iWidth ] = true;
+				break;
+			case 6:
+				// no
+				break;
+			}
+			break;
+		}
+
+		assert( iX >= 0 && iX <= iWidth );
+		assert( iY >= 0 && iY <= iHeight );
+
+		iX += iDiffX;
+		iY += iDiffY;
+		iDir = iNewDir;
+	}
+
+	// finalize edge chain
+	if( iX == iWidth-1 )
+	{
+		if( iY == 0 )
+		{
+			if( iDir == 1 )
+			{
+				pbEdge[ 2 * iX + (2 * iY + 1) * 2 * iWidth ] = true;
+			}
+			else if( iDir == 5 )
+			{
+				pbEdge[ 2 * iX + (2 * iY + 1) * 2 * iWidth ] = true;
+			}
+			else
+			{
+				assert(false);
+			}
+		}
+		else if( iY == iHeight-1 )
+		{
+			if( iDir == 3 )
+			{
+				pbEdge[ 2 * iX - 1 + 2 * iY * 2 * iWidth ] = true;
+			}
+			else if( iDir == 7 )
+			{
+				pbEdge[ 2 * iX - 1 + 2 * iY * 2 * iWidth ] = true;
+			}
+			else
+			{
+				assert(false);
+			}
+		}
+		else
+		{
+			if( iDir == 1 )
+			{
+				pbEdge[ 2 * iX + (2 * iY + 1) * 2 * iWidth ] = true;
+			}
+			else if( iDir == 3 )
+			{
+				pbEdge[ 2 * iX - 1 + 2 * iY * 2 * iWidth ] = true;
+				pbEdge[ 2 * iX + (2 * iY + 1) * 2 * iWidth ] = true;
+			}
+			else if( iDir == 5 )
+			{
+				pbEdge[ 2 * iX + (2 * iY + 1) * 2 * iWidth ] = true;
+			}
+			else if( iDir == 7 )
+			{
+				pbEdge[ 2 * iX - 1 + 2 * iY * 2 * iWidth ] = true;
+				pbEdge[ 2 * iX + (2 * iY + 1) * 2 * iWidth ] = true;
+			}
+			else
+			{
+				assert(false);
+			}
+		}
+	}
+	else if( iX == 0 )
+	{
+		if( iY == 0 )
+		{
+			if( iDir == 2 )
+			{
+				pbEdge[ 2 * iX + 1 + 2 * iY * 2 * iWidth ] = true;
+			}
+			else if( iDir == 4 )
+			{
+				pbEdge[ 2 * iX + 1 + 2 * iY * 2 * iWidth ] = true;
+			}
+			else
+			{
+				assert(false);
+			}
+		}
+		else if( iY == iHeight-1 )
+		{
+			if( iDir == 0 )
+			{
+				pbEdge[ 2 * iX + (2 * iY - 1) * 2 * iWidth ] = true;
+			}
+			else if( iDir == 6 )
+			{
+				pbEdge[ 2 * iX + (2 * iY - 1) * 2 * iWidth ] = true;
+			}
+			else
+			{
+				assert(false);
+			}
+		}
+		else
+		{
+			if( iDir == 0 )
+			{
+				pbEdge[ 2 * iX + (2 * iY - 1) * 2 * iWidth ] = true;
+			}
+			else if( iDir == 2 )
+			{
+				pbEdge[ 2 * iX + 1 + 2 * iY * 2 * iWidth ] = true;
+				pbEdge[ 2 * iX + (2 * iY - 1) * 2 * iWidth ] = true;
+			}
+			else if( iDir == 4 )
+			{
+				pbEdge[ 2 * iX + 1 + 2 * iY * 2 * iWidth ] = true;
+				pbEdge[ 2 * iX + (2 * iY - 1) * 2 * iWidth ] = true;
+			}
+			else if( iDir == 6 )
+			{
+				pbEdge[ 2 * iX + (2 * iY - 1) * 2 * iWidth ] = true;
+			}
+			else
+			{
+				assert(false);
+			}
+		}
+	}
+	else if( iY == 0 )
+	{
+		if( iDir == 1 )
+		{
+			pbEdge[ 2 * iX + (2 * iY + 1) * 2 * iWidth ] = true;
+			pbEdge[ 2 * iX + 1 + 2 * iY * 2 * iWidth ] = true;
+		}
+		else if( iDir == 2 )
+		{
+			pbEdge[ 2 * iX + 1 + 2 * iY * 2 * iWidth ] = true;
+		}
+		else if( iDir == 4 )
+		{
+			pbEdge[ 2 * iX + 1 + 2 * iY * 2 * iWidth ] = true;
+		}
+		else if( iDir == 5 )
+		{
+			pbEdge[ 2 * iX + (2 * iY + 1) * 2 * iWidth ] = true;
+			pbEdge[ 2 * iX + 1 + 2 * iY * 2 * iWidth ] = true;
+		}
+		else
+		{
+			assert(false);
+		}
+	}
+	else if( iY == iHeight-1 )
+	{
+		if( iDir == 0 )
+		{
+			pbEdge[ 2 * iX + (2 * iY - 1) * 2 * iWidth ] = true;
+			pbEdge[ 2 * iX - 1 + 2 * iY * 2 * iWidth ] = true;
+		}
+		else if( iDir == 3 )
+		{
+			pbEdge[ 2 * iX - 1 + 2 * iY * 2 * iWidth ] = true;
+		}
+		else if( iDir == 6 )
+		{
+			pbEdge[ 2 * iX + (2 * iY - 1) * 2 * iWidth ] = true;
+			pbEdge[ 2 * iX - 1 + 2 * iY * 2 * iWidth ] = true;
+		}
+		else if( iDir == 7 )
+		{
+			pbEdge[ 2 * iX - 1 + 2 * iY * 2 * iWidth ] = true;
+		}
+		else
+		{
+			assert(false);
+		}
+	}
+	else
+	{
+		printf("xPredIntraEdge: wrong termination\n");
+		assert(false);
+	}
+
+	// Reconstruct Region from Chain Code
+	Bool* pbVisit  = (Bool*) xMalloc( Bool, iWidth * iHeight );
+	Int*  piStack  = (Int* ) xMalloc( Int,  iWidth * iHeight );
+
+	for( UInt ui = 0; ui < iWidth * iHeight; ui++ )
+	{
+		pbRegion[ ui ] = true; // fill it as region 1 (we'll discover region 0 next)
+		pbVisit [ ui ] = false;
+	}
+
+	iPtr = 0;
+	piStack[iPtr++] = (0 << 8) | (0);
+	pbRegion[ 0 ] = false;
+
+	while(iPtr > 0)
+	{
+		Int iTmp = piStack[--iPtr];
+		Int iX1, iY1;
+		iX1 = iTmp & 0xff;
+		iY1 = (iTmp >> 8) & 0xff;
+
+		pbVisit[ iX1 + iY1 * iWidth ] = true;
+
+		assert( iX1 >= 0 && iX1 < iWidth );
+		assert( iY1 >= 0 && iY1 < iHeight );
+
+		if( iX1 > 0 && !pbEdge[ 2 * iX1 - 1 + 4 * iY1 * iWidth ] && !pbVisit[ iX1 - 1 + iY1 * iWidth ] )
+		{
+			piStack[iPtr++] = (iY1 << 8) | (iX1 - 1);
+			pbRegion[ iX1 - 1 + iY1 * iWidth ] = false;
+		}
+		if( iX1 < iWidth - 1 && !pbEdge[ 2 * iX1 + 1 + 4 * iY1 * iWidth ] && !pbVisit[ iX1 + 1 + iY1 * iWidth ] )
+		{
+			piStack[iPtr++] = (iY1 << 8) | (iX1 + 1);
+			pbRegion[ iX1 + 1 + iY1 * iWidth ] = false;
+		}
+		if( iY1 > 0 && !pbEdge[ 2 * iX1 + 2 * (2 * iY1 - 1) * iWidth ] && !pbVisit[ iX1 + (iY1 - 1) * iWidth ] )
+		{
+			piStack[iPtr++] = ((iY1 - 1) << 8) | iX1;
+			pbRegion[ iX1 + (iY1 - 1) * iWidth ] = false;
+		}
+		if( iY1 < iHeight - 1 && !pbEdge[ 2 * iX1 + 2 * (2 * iY1 + 1) * iWidth ] && !pbVisit[ iX1 + (iY1 + 1) * iWidth ] )
+		{
+			piStack[iPtr++] = ((iY1 + 1) << 8) | iX1;
+			pbRegion[ iX1 + (iY1 + 1) * iWidth ] = false;
+		}
+	}
+
+	xFree( pbEdge );
+	xFree( pbVisit );
+	xFree( piStack );
+}
+
+#endif
+
 //! \}
Index: branches/HTM-3.1-LG/source/Lib/TLibCommon/TComDataCU.h
===================================================================
--- branches/HTM-3.1-LG/source/Lib/TLibCommon/TComDataCU.h	(revision 96)
+++ branches/HTM-3.1-LG/source/Lib/TLibCommon/TComDataCU.h	(revision 97)
@@ -214,4 +214,16 @@
 #endif
 
+#if LGE_EDGE_INTRA
+  UChar*        m_pucEdgeCode;          ///< array of edge code
+  UChar*        m_pucEdgeNumber;        ///< total number of edge
+  UChar*        m_pucEdgeStartPos;      ///< starting point position
+  Bool*         m_pbEdgeLeftFirst;      ///< true if edge should be checked in left boundary first
+  Bool*         m_pbEdgePartition;      ///< true if it belongs to region 1, otherwise, region 0
+#if LGE_EDGE_INTRA_DELTA_DC
+  Int*          m_piEdgeDeltaDC0;
+  Int*          m_piEdgeDeltaDC1;
+#endif
+#endif
+
   // -------------------------------------------------------------------------------------------------------------------
   // misc. variables
@@ -513,4 +525,8 @@
   Int           getPdmMergeCandidateDisCan( UInt uiPartIdx, Int* paiPdmRefIdx, TComMv* pacPdmMv, DisInfo* pDInfo );
   Void          getDisMvpCand        ( UInt uiPartIdx, UInt uiPartAddr, DisInfo* pDInfo );
+#if USE_DVMCP
+  Void          getDisMvpCand2( UInt uiPartIdx, UInt uiPartAddr, DisInfo* pDInfo, Bool bMerge=false, RefPicList eRefPicList=REF_PIC_LIST_X, Int iRefIdx=-1 );
+#endif
+
 #endif
   Bool          getIViewOrgDepthMvPred( UInt uiPartIdx, RefPicList eRefPicList, Int iRefIdx, TComMv& rcMv );
@@ -668,4 +684,9 @@
   UInt          getEntropySliceStartCU  ( UInt pos )                  { return m_uiEntropySliceStartCU[pos-m_uiAbsIdxInLCU];                                                                                   }
   UInt&         getTotalBins            ()                            { return m_uiTotalBins;                                                                                                  }
+
+#if LGE_EDGE_INTRA
+  UInt          getCtxEdgeIntra ( UInt uiAbsPartIdx );
+#endif
+
   // -------------------------------------------------------------------------------------------------------------------
   // member functions for RD cost storage
@@ -743,4 +764,28 @@
   Void  setContourPredTexDeltaDC2SubParts ( Int iDC2, UInt uiAbsPartIdx, UInt uiDepth );
 #endif
+
+#if LGE_EDGE_INTRA
+  UChar*        getEdgeCode( UInt uiIdx )                 { return &m_pucEdgeCode[uiIdx * LGE_EDGE_INTRA_MAX_EDGE_NUM_PER_4x4]; }
+  UChar*        getEdgeNumber( )                          { return m_pucEdgeNumber;           }
+  UChar         getEdgeNumber( UInt uiIdx )               { return m_pucEdgeNumber[uiIdx];    }
+  Void          setEdgeNumber( UInt uiIdx, UChar val )    { m_pucEdgeNumber[uiIdx] = val;     }
+  UChar*        getEdgeStartPos( )                        { return m_pucEdgeStartPos;         }
+  UChar         getEdgeStartPos( UInt uiIdx )             { return m_pucEdgeStartPos[uiIdx];  }
+  Void          setEdgeStartPos( UInt uiIdx, UChar val )  { m_pucEdgeStartPos[uiIdx] = val;   }
+  Bool*         getEdgeLeftFirst( )                       { return m_pbEdgeLeftFirst;         }
+  Bool          getEdgeLeftFirst( UInt uiIdx )            { return m_pbEdgeLeftFirst[uiIdx];  }
+  Void          setEdgeLeftFirst( UInt uiIdx, Bool val )  { m_pbEdgeLeftFirst[uiIdx] = val;   }
+  Bool*         getEdgePartition( UInt uiIdx )              { return &m_pbEdgePartition[uiIdx * 16]; }
+  Void          reconPartition( UInt uiAbsPartIdx, UInt uiDepth, Bool bLeft, UChar ucStartPos, UChar ucNumEdge, UChar* pucEdgeCode, Bool* pbRegion );
+
+#if LGE_EDGE_INTRA_DELTA_DC
+  Int*          getEdgeDeltaDC0( )                          { return m_piEdgeDeltaDC0; }
+  Int*          getEdgeDeltaDC1( )                          { return m_piEdgeDeltaDC1; }
+  Int           getEdgeDeltaDC0( UInt uiIdx )               { return m_piEdgeDeltaDC0[uiIdx]; }
+  Int           getEdgeDeltaDC1( UInt uiIdx )               { return m_piEdgeDeltaDC1[uiIdx]; }
+  Void          setEdgeDeltaDC0( UInt uiIdx, Int val )      { m_piEdgeDeltaDC0[uiIdx] = val;  }
+  Void          setEdgeDeltaDC1( UInt uiIdx, Int val )      { m_piEdgeDeltaDC1[uiIdx] = val;  }
+#endif
+#endif
 };
 
Index: branches/HTM-3.1-LG/source/Lib/TLibCommon/TComDepthMapGenerator.cpp
===================================================================
--- branches/HTM-3.1-LG/source/Lib/TLibCommon/TComDepthMapGenerator.cpp	(revision 96)
+++ branches/HTM-3.1-LG/source/Lib/TLibCommon/TComDepthMapGenerator.cpp	(revision 97)
@@ -831,4 +831,7 @@
 TComDepthMapGenerator::getDisCanPdmMvPred    ( TComDataCU*   pcCU, UInt uiPartIdx, RefPicList eRefPicList, Int iRefIdx, TComMv& rcMv, DisInfo* pDInfo, Bool bMerge )
 {
+#if USE_DVMCP
+  rcMv.m_bDvMcp = false;
+#endif
   AOF  ( m_bCreated && m_bInit );
   AOF  ( iRefIdx >= 0 );
@@ -892,4 +895,15 @@
       {
         rcMv.set( cBaseMvField.getHor(), cBaseMvField.getVer() );
+#if USE_DVMCP
+        // save disparity vector when a merge candidate for IVMP is set as DV-MCP
+        if( bMerge ) 
+        {
+          rcMv.m_bDvMcp = true;
+          rcMv.m_iDvMcpDispX = pDInfo->m_acMvCand[0].getHor(); 
+        }
+        else { // AMVP ?
+          rcMv.m_bDvMcp = false;
+        }
+#endif
         return true;
       }
Index: branches/HTM-3.1-LG/source/Lib/TLibCommon/TComMv.h
===================================================================
--- branches/HTM-3.1-LG/source/Lib/TLibCommon/TComMv.h	(revision 96)
+++ branches/HTM-3.1-LG/source/Lib/TLibCommon/TComMv.h	(revision 97)
@@ -57,4 +57,9 @@
 public:
   
+#if USE_DVMCP
+  Bool  m_bDvMcp;       // is dv-mcp ?
+  Int   m_iDvMcpDispX;  // disparity for dv-mcp
+#endif
+
   // ------------------------------------------------------------------------------------------------------------------
   // constructors
@@ -64,4 +69,8 @@
   m_iHor(0),
   m_iVer(0)
+#if USE_DVMCP
+  , m_bDvMcp(false)
+  , m_iDvMcpDispX(0)
+#endif
   {
   }
@@ -70,4 +79,8 @@
   m_iHor(iHor),
   m_iVer(iVer)
+#if USE_DVMCP
+  , m_bDvMcp(false)
+  , m_iDvMcpDispX(0)
+#endif
   {
   }
Index: branches/HTM-3.1-LG/source/Lib/TLibCommon/TComPattern.cpp
===================================================================
--- branches/HTM-3.1-LG/source/Lib/TLibCommon/TComPattern.cpp	(revision 96)
+++ branches/HTM-3.1-LG/source/Lib/TLibCommon/TComPattern.cpp	(revision 97)
@@ -675,4 +675,7 @@
 {
   Int* piSrc;
+#if LGE_EDGE_INTRA
+  mapEdgeIntratoDC( uiDirMode );
+#endif
   assert(log2BlkSize >= 2 && log2BlkSize < 7);
 #if HHI_DMM_WEDGE_INTRA || HHI_DMM_PRED_TEX
Index: branches/HTM-3.1-LG/source/Lib/TLibCommon/TComPic.h
===================================================================
--- branches/HTM-3.1-LG/source/Lib/TLibCommon/TComPic.h	(revision 96)
+++ branches/HTM-3.1-LG/source/Lib/TLibCommon/TComPic.h	(revision 97)
@@ -73,4 +73,8 @@
 #endif
 
+#if LG_ZEROINTRADEPTHRESI_M26039
+  Int                   m_uiIntraPeriod;
+#endif
+
 #if HHI_INTER_VIEW_MOTION_PRED
   TComPicYuv*           m_pcOrgDepthMap;          //  original depth map
@@ -129,4 +133,8 @@
 #if VIDYO_VPS_INTEGRATION
   TComVPS*      getVPS()              { return  m_apcPicSym->getSlice(m_uiCurrSliceIdx)->getVPS();  }
+#endif
+#if LG_ZEROINTRADEPTHRESI_M26039
+  Int           getIntraPeriod()                           { return  m_uiIntraPeriod; }
+  Void          setIntraPeriod(Int uiIntraPeriod)          { m_uiIntraPeriod = uiIntraPeriod; }
 #endif
   TComSPS*      getSPS()              { return  m_apcPicSym->getSlice(m_uiCurrSliceIdx)->getSPS();  }
Index: branches/HTM-3.1-LG/source/Lib/TLibCommon/TComPrediction.cpp
===================================================================
--- branches/HTM-3.1-LG/source/Lib/TLibCommon/TComPrediction.cpp	(revision 96)
+++ branches/HTM-3.1-LG/source/Lib/TLibCommon/TComPrediction.cpp	(revision 97)
@@ -419,4 +419,184 @@
 }
 
+#if LGE_EDGE_INTRA
+Void TComPrediction::predIntraLumaEdge ( TComDataCU* pcCU, TComPattern* pcTComPattern, UInt uiAbsPartIdx, Int iWidth, Int iHeight, Pel* piPred, UInt uiStride, Bool bDelta )
+{
+	Pel *piDst = piPred;
+	Int *piSrc;
+	Int iSrcStride = ( iWidth<<1 ) + 1;
+	Int iDstStride = uiStride;
+
+	piSrc = pcTComPattern->getPredictorPtr( 0, g_aucConvertToBit[ iWidth ] + 2, m_piYuvExt );
+
+	xPredIntraEdge ( pcCU, uiAbsPartIdx, iWidth, iHeight, piSrc, iSrcStride, piDst, iDstStride
+#if LGE_EDGE_INTRA_DELTA_DC
+		, bDelta
+#endif
+		);
+}
+
+Pel  TComPrediction::xGetNearestNeighbor( Int x, Int y, Int* pSrc, Int srcStride, Int iWidth, Int iHeight, Bool* bpRegion )
+{
+	Bool bLeft = (x < y) ? true : false;
+	Bool bFound = false;
+	Int  iFoundX = -1, iFoundY = -1;
+	Int  cResult = 0;
+
+#define MAX_DISTANCE_EDGEINTRA 255
+
+	UChar* piTopDistance = new UChar[iWidth];
+	UChar* piLeftDistance = new UChar[iHeight];
+
+	for( Int i = 0; i < iWidth; i++ )
+	{
+		int Abs = x > i ? x - i : i - x;
+		piTopDistance[ i ] = y + Abs;
+
+		Abs = y > i ? y - i : i - y;
+		piLeftDistance[ i ] = x + Abs;
+	}
+
+	for( Int dist = 0; dist < MAX_DISTANCE_EDGEINTRA && !bFound; dist++ )
+	{
+		if( !bLeft )
+		{
+			for( Int i = 0; i < iWidth; i++ )
+			{
+				if( piTopDistance[ i ] == dist )
+				{
+					if( bpRegion[ i ] == bpRegion[ x + y * iWidth ] )
+					{
+						iFoundX = i;
+						iFoundY = 0;
+						bFound = true;
+					}
+				}
+			}
+			for( Int i = 0; i < iHeight; i++ )
+			{
+				if( piLeftDistance[ i ] == dist )
+				{
+					if( bpRegion[ i * iWidth ] == bpRegion[ x + y * iWidth ] )
+					{
+						iFoundX = 0;
+						iFoundY = i;
+						bFound = true;
+					}
+				}
+			}
+		}
+		else
+		{
+			for( Int i = 0; i < iHeight; i++ )
+			{
+				if( piLeftDistance[ i ] == dist )
+				{
+					if( bpRegion[ i * iWidth ] == bpRegion[ x + y * iWidth ] )
+					{
+						iFoundX = 0;
+						iFoundY = i;
+						bFound = true;
+					}
+				}
+			}
+			for( Int i = 0; i < iWidth; i++ )
+			{
+				if( piTopDistance[ i ] == dist )
+				{
+					if( bpRegion[ i ] == bpRegion[ x + y * iWidth ] )
+					{
+						iFoundX = i;
+						iFoundY = 0;
+						bFound = true;
+					}
+				}
+			}
+		}
+	}
+
+	if( iFoundY == 0 )
+	{
+		cResult = pSrc[ iFoundX + 1 ];
+	}
+	else // iFoundX == 0
+	{
+		cResult = pSrc[ (iFoundY + 1) * srcStride ];
+	}
+
+	delete[] piTopDistance;  piTopDistance = NULL;
+	delete[] piLeftDistance; piLeftDistance = NULL;
+
+	assert( bFound );
+
+	return cResult;
+}
+
+Void TComPrediction::xPredIntraEdge( TComDataCU* pcCU, UInt uiAbsPartIdx, Int iWidth, Int iHeight, Int* pSrc, Int srcStride, Pel*& rpDst, Int dstStride, Bool bDelta )
+{
+	Pel* pDst = rpDst;
+	Bool* pbRegion = pcCU->getEdgePartition( uiAbsPartIdx );
+
+	// Do prediction
+	{
+		UInt uiSum0 = 0, uiSum1 = 0;
+		UInt uiMean0, uiMean1;
+		UInt uiCount0 = 0, uiCount1 = 0;
+		for( UInt ui = 0; ui < iWidth; ui++ )
+		{
+			if( pbRegion[ ui ] == false )
+			{
+				uiSum0 += (pSrc[ ui + 1 ]);
+				uiCount0++;
+			}
+			else
+			{
+				uiSum1 += (pSrc[ ui + 1 ]);
+				uiCount1++;
+			}
+		}
+		for( UInt ui = 0; ui < iHeight; ui++ ) // (0,0) recount (to avoid division)
+		{
+			if( pbRegion[ ui * iWidth ] == false )
+			{
+				uiSum0 += (pSrc[ (ui + 1) * srcStride ]);
+				uiCount0++;
+			}
+			else
+			{
+				uiSum1 += (pSrc[ (ui + 1) * srcStride ]);
+				uiCount1++;
+			}
+		}
+		if( uiCount0 == 0 )
+			assert(false);
+		if( uiCount1 == 0 )
+			assert(false);
+		uiMean0 = uiSum0 / uiCount0; // TODO : integer op.
+		uiMean1 = uiSum1 / uiCount1;
+#if LGE_EDGE_INTRA_DELTA_DC
+		if( bDelta ) 
+		{
+			Int iDeltaDC0 = pcCU->getEdgeDeltaDC0( uiAbsPartIdx );
+			Int iDeltaDC1 = pcCU->getEdgeDeltaDC1( uiAbsPartIdx );
+			xDeltaDCQuantScaleUp( pcCU, iDeltaDC0 );
+			xDeltaDCQuantScaleUp( pcCU, iDeltaDC1 );
+			uiMean0 = Clip( uiMean0 + iDeltaDC0 );
+			uiMean1 = Clip( uiMean1 + iDeltaDC1 );
+		}
+#endif
+		for( UInt ui = 0; ui < iHeight; ui++ )
+		{
+			for( UInt uii = 0; uii < iWidth; uii++ )
+			{
+				if( pbRegion[ uii + ui * iWidth ] == false )
+					pDst[ uii + ui * dstStride ] = uiMean0;
+				else
+					pDst[ uii + ui * dstStride ] = uiMean1;
+			}
+		}
+	}
+}
+#endif
+
 #if DEPTH_MAP_GENERATION
 Void TComPrediction::motionCompensation( TComDataCU* pcCU, TComYuv* pcYuvPred, RefPicList eRefPicList, Int iPartIdx, Bool bPrdDepthMap, UInt uiSubSampExpX, UInt uiSubSampExpY )
Index: branches/HTM-3.1-LG/source/Lib/TLibCommon/TComPrediction.h
===================================================================
--- branches/HTM-3.1-LG/source/Lib/TLibCommon/TComPrediction.h	(revision 96)
+++ branches/HTM-3.1-LG/source/Lib/TLibCommon/TComPrediction.h	(revision 97)
@@ -125,4 +125,9 @@
 #endif
 
+#if LGE_EDGE_INTRA
+  Pel  xGetNearestNeighbor  ( Int x, Int y, Int* pSrc, Int srcStride, Int iWidth, Int iHeight, Bool* bpRegion );
+  Void xPredIntraEdge       ( TComDataCU* pcCU, UInt uiAbsPartIdx, Int iWidth, Int iHeight, Int* pSrc, Int srcStride, Pel*& rpDst, Int dstStride, Bool bDelta = false );
+#endif
+
 public:
   TComPrediction();
@@ -170,4 +175,7 @@
   Bool  getWedgePatternIdx      ( WedgeRefList* pcWedgeRefList, UInt& ruiTabIdx, UChar uhXs, UChar uhYs, UChar uhXe, UChar uhYe );
 #endif
+#if LGE_EDGE_INTRA
+  Void predIntraLumaEdge          ( TComDataCU* pcCU, TComPattern* pcTComPattern, UInt uiAbsPartIdx, Int iWidth, Int iHeight, Pel* piPred, UInt uiStride, Bool bDelta = false );
+#endif
 
   // simplified intra pred for "virtual" depth maps
Index: branches/HTM-3.1-LG/source/Lib/TLibCommon/TComRom.h
===================================================================
--- branches/HTM-3.1-LG/source/Lib/TLibCommon/TComRom.h	(revision 96)
+++ branches/HTM-3.1-LG/source/Lib/TLibCommon/TComRom.h	(revision 97)
@@ -206,4 +206,10 @@
 #endif
 
+#if LGE_EDGE_INTRA
+__inline Void mapEdgeIntratoDC( UChar& curDir ) { curDir = (curDir >= EDGE_INTRA_IDX) ? DC_IDX : curDir; }
+__inline Void mapEdgeIntratoDC(  UInt& curDir ) { curDir = (curDir >= EDGE_INTRA_IDX) ? DC_IDX : curDir; }
+__inline Void mapEdgeIntratoDC(   Int& curDir ) { curDir = (curDir >= EDGE_INTRA_IDX) ? DC_IDX : curDir; }
+#endif
+
 // ==========================================
 // Mode-Dependent DST Matrices
Index: branches/HTM-3.1-LG/source/Lib/TLibCommon/TypeDef.h
===================================================================
--- branches/HTM-3.1-LG/source/Lib/TLibCommon/TypeDef.h	(revision 96)
+++ branches/HTM-3.1-LG/source/Lib/TLibCommon/TypeDef.h	(revision 97)
@@ -42,4 +42,16 @@
 //! \{
 
+#define LGE_EDGE_INTRA                  1       //JCT2-A0070
+#if LGE_EDGE_INTRA
+#define LGE_EDGE_INTRA_MIN_SIZE         4
+#define LGE_EDGE_INTRA_MAX_SIZE        32
+#define LGE_EDGE_INTRA_THRESHOLD       20
+#define LGE_EDGE_INTRA_MAX_EDGE_NUM_PER_4x4 8
+#define LGE_EDGE_INTRA_DELTA_DC         1 
+#define LGE_EDGE_INTRA_PIXEL_DIFFERENCE 1
+#endif
+
+#define LG_ZEROINTRADEPTHRESI_M26039      1  //JCT2-A0087
+
 #define SONY_COLPIC_AVAILABILITY          1
 
@@ -54,4 +66,15 @@
 #define MTK_INTERVIEW_MERGE_A0049         1 //  JCT2-A0049 second part
 
+#if QC_MULTI_DIS_CAN                    // JCT2-A0126
+#define USE_DVMCP         0 
+
+#define DVFROM_LEFTBELOW  1
+#define DVFROM_LEFT       2
+#define DVFROM_ABOVERIGHT 3
+#define DVFROM_ABOVE      4
+#define DVFROM_ABOVELEFT  5
+#define DVFROM_COL        6
+#endif
+
 
 #define HHI_VSO                           1
@@ -231,5 +254,13 @@
 #define LOG2_SCAN_SET_SIZE                4
 
+#if LGE_EDGE_INTRA
+#if LGE_EDGE_INTRA_DELTA_DC
+#define FAST_UDI_MAX_RDMODE_NUM               37          ///< maximum number of RD comparison in fast-UDI estimation loop
+#else
+#define FAST_UDI_MAX_RDMODE_NUM               36          ///< maximum number of RD comparison in fast-UDI estimation loop
+#endif
+#else
 #define FAST_UDI_MAX_RDMODE_NUM               35          ///< maximum number of RD comparison in fast-UDI estimation loop
+#endif
 
 #define ZERO_MVD_EST                          0           ///< Zero Mvd Estimation in normal mode
@@ -270,4 +301,13 @@
 #define NUM_DMM_MODE 4
 #endif
+
+#if LGE_EDGE_INTRA
+#if HHI_DMM_WEDGE_INTRA && HHI_DMM_PRED_TEX
+#define EDGE_INTRA_IDX  (NUM_INTRA_MODE+NUM_DMM_MODE)
+#endif // HHI_DMM_WEDGE_INTRA && HHI_DMM_PRED_TEX
+#if LGE_EDGE_INTRA_DELTA_DC
+#define EDGE_INTRA_DELTA_IDX          (EDGE_INTRA_IDX+1)
+#endif
+#endif // LGE_EDGE_INTRA
 
 #define IBDI_DISTORTION                0           ///< enable/disable SSE modification when IBDI is used (JCTVC-D152)
